

//+------------------------------------------------------------------+
//|                            AutoRG5.mq4                           |
//|                            EUR/USD 5m                            |
//+------------------------------------------------------------------+


//---- perceptron parameters
extern int    x1 = 2760;
extern int    x2 = 570;
extern int    x3 = 960;
extern int    x4 = 4240;

extern int ww1=190;
extern int ww2=30;
extern int ww3=110;
extern int ww4=140;

extern int aa1=0;
extern int aa2=52;
extern int aa3=15;
extern int aa4=22;

extern int aaa1=25;
extern int aaa2=100;
extern int aaa3=30;
extern int aaa4=66;

extern double sl = 110; //590
extern int ModifySL= 50;
extern int ModifyTP= 100; 
extern int Target=250;
extern double lots = 3;
extern int MagicNumber = 1890;//78548
static int prevtime = 0;

//---- awesome parameters

extern int short_mean = 5;
extern int long_mean = 34;
extern int meanAO = 7;

//---- multi signal parameters

extern int MACD_Fast = 8;
extern int MACD_Slow = 17;
extern int MACD_Signal = 9;
extern int MACD_PRICE_TYPE = 0;

extern int RSI_Period = 9;
extern int RSI_PRICE_TYPE = 0;

extern int CCI_Period = 13;
extern int CCI_PRICE_TYPE = 0;

extern int STOCH_K_Period = 5;
extern int STOCH_D_Period = 3;
extern int STOCH_Slowing = 3;
extern int STOCH_MA_MODE = 1;

extern int MA_Fast = 5;
extern int MA_Slow = 9;
extern int MA_MODE = 1;
extern int MA_PRICE_TYPE = 0;



//+------------------------------------------------------------------+
//| initialization function                                          |
//+------------------------------------------------------------------+
int init()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| deinitialization function                                        |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| start function                                                   |
//+------------------------------------------------------------------+
int start()
  {
   if(Time[0] == prevtime) 
       return(0);
   prevtime = Time[0];
   int spread = 3;
//----
   if(IsTradeAllowed()) 
     {
       RefreshRates();
       spread = MarketInfo(Symbol(), MODE_SPREAD);
     } 
   else 
     {
       prevtime = Time[1];
       return(0);
     }
     
//---- macd signals

double MACDM1=iMACD(NULL,1,MACD_Fast,MACD_Slow,MACD_Signal,MACD_PRICE_TYPE,MODE_MAIN,0); 
double MACD_SIGM1=iMACD(NULL,1,MACD_Fast,MACD_Slow,MACD_Signal,MACD_PRICE_TYPE,MODE_SIGNAL,0);    
double MACDM5=iMACD(NULL,5,MACD_Fast,MACD_Slow,MACD_Signal,MACD_PRICE_TYPE,MODE_MAIN,0); 
double MACD_SIGM5=iMACD(NULL,5,MACD_Fast,MACD_Slow,MACD_Signal,MACD_PRICE_TYPE,MODE_SIGNAL,0);
double MACDM15=iMACD(NULL,15,MACD_Fast,MACD_Slow,MACD_Signal,MACD_PRICE_TYPE,MODE_MAIN,0); 
double MACD_SIGM15=iMACD(NULL,15,MACD_Fast,MACD_Slow,MACD_Signal,MACD_PRICE_TYPE,MODE_SIGNAL,0);       


//---- str signals

double rsi_m15= iRSI(NULL, PERIOD_M15, RSI_Period , RSI_PRICE_TYPE, 0);
double rsi_m5= iRSI(NULL, PERIOD_M5, RSI_Period , RSI_PRICE_TYPE, 0);
double rsi_m1= iRSI(NULL, PERIOD_M1, RSI_Period , RSI_PRICE_TYPE, 0);


double stoc_M15= iStochastic(NULL, PERIOD_M15, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
double stoc_M5= iStochastic(NULL, PERIOD_M5, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
double stoc_M1= iStochastic(NULL, PERIOD_M1, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);

    
double cci_MM15= iCCI(NULL, PERIOD_M15,CCI_Period , CCI_PRICE_TYPE, 0);    
double cci_MM5= iCCI(NULL, PERIOD_M5,CCI_Period , CCI_PRICE_TYPE, 0);       
double cci_MM1= iCCI(NULL, PERIOD_M1,CCI_Period , CCI_PRICE_TYPE, 0);

// ma signals

double EMA_M1= iMA(Symbol(),1,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
double ema_m1= iMA(Symbol(),1,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
double EMA_M5= iMA(Symbol(),5,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
double ema_m5= iMA(Symbol(),5,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
double EMA_M15= iMA(Symbol(),15,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
double ema_m15= iMA(Symbol(),15,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);

double up_signal_buffer_2 = EMPTY_VALUE ; 
double down_signal_buffer_3 = EMPTY_VALUE ; 

up_signal_buffer_2 = iCustom(NULL,0,"The Legacy  Trader MT4 Indicator" , 2, 1); 
down_signal_buffer_3 = iCustom(NULL,0,"The Legacy  Trader MT4 Indicator" , 3, 1); 

//---- signal conditions

bool macdShort= ((MACDM1<=MACD_SIGM1)&& (MACDM5<=MACD_SIGM5)&& (MACDM15<=MACD_SIGM15));
bool macdLong=  ((MACDM1>MACD_SIGM1) && (MACDM5>MACD_SIGM5) && (MACDM15>MACD_SIGM15));

bool strShort=  ((rsi_m5 < 50) && (stoc_M5 < 60) && (cci_MM5 < 0) && (rsi_m15 < 50) && (stoc_M15 < 60) && (cci_MM15 < 0));
bool strLong=    ((rsi_m5 > 50) && (stoc_M5 > 40) && (cci_MM5 > 0) && (rsi_m15 > 50) && (stoc_M15 > 40) && (cci_MM15 > 0));

bool maShort=   ((EMA_M1 <= ema_m1) && (EMA_M5 <= ema_m5) && (EMA_M15 <= ema_m15));
bool maLong=    ((EMA_M1 > ema_m1) | (EMA_M5 > ema_m5) | (EMA_M15 > ema_m15));

bool TradeLong= ((macdLong) && (strLong) && (maLong));
bool TradeShort= ((macdShort) && (strShort) && (maShort));

//---- awesome filter

double AW       = iCustom(NULL,0,"Awesome",0,0);
double lime_AW  = iCustom(NULL,0,"Awesome",1,0);
double red_AW   = iCustom(NULL,0,"Awesome",2,0);


   //
   //
   //
   //
   //
        
   int ticket = -1;      double lot_buy = 0, lot_sell = 0;
   double profit_buy  =-1000; double profit_sell = -1000;

// check for opened position
   int total = OrdersTotal();   
//----
   for(int i = total; i >=0; i-- ) 
     {
       bool result = OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       // check for symbol & magic number
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
           int prevticket = OrderTicket();
           // long position is opened
           if(OrderType() == OP_BUY) 
             {
              lot_buy = OrderLots(); profit_buy = OrderProfit();
               // check profit 
               if(Bid > (OrderStopLoss() + (sl * 2  + spread) * Point)) 
                 {  // if signal down
                   if((perceptron() < 0) && (TradeShort=True) &&(AW < 0 && red_AW != 0.0) && ( down_signal_buffer_3 != EMPTY_VALUE ));            
                     { // reverse                                                                 // erreur
                       ticket = OrderSend(Symbol(), OP_SELL, lots * 2, Bid, 3, Ask + sl * Point,0, "AI", MagicNumber, 0, Red); 
                       Sleep(20000);
                       //----
                       if(ticket < 0)           prevtime = Time[1];
                       else                      result = OrderCloseBy(ticket, prevticket, Blue);   
                     } 
                  
                 }  
               // short position is opened
             } 
           else 
             {
              lot_sell = OrderLots(); profit_sell = OrderProfit();
               // check profit 
               if(Ask < (OrderStopLoss() - (sl * 2 + spread) * Point)) 
                 {
                   if((perceptron() > 0) && (TradeLong=True) && (AW> 0 && lime_AW !=0.0)  && (up_signal_buffer_2 != EMPTY_VALUE));  
                     { // reverse
                       ticket = OrderSend(Symbol(), OP_BUY, lots * 2, Ask, 3, Bid - sl * Point, 0, "AI", MagicNumber, 0, Blue); 
                       Sleep(20000);
                       //----
                       if(ticket < 0)         prevtime = Time[1];
                       else                   result   = OrderCloseBy(ticket, prevticket, Blue);   
                     } 

                 }  
             }
            string Nom_EA ="AutoRG5_II";
       ObjectDelete (Nom_EA+"lots" );
       ObjectCreate (Nom_EA+"lots" , OBJ_LABEL, 0 ,0,0);
       ObjectSet    (Nom_EA+"lots" , OBJPROP_XDISTANCE, 50  );
       ObjectSet    (Nom_EA+"lots" , OBJPROP_YDISTANCE,50 );
       ObjectSetText(Nom_EA+"lots", "LOT   buy    "+lot_buy+"   "+profit_buy+"   sell    "+lot_sell+"    "+profit_sell, 8, "Arial Black", PaleGreen );
       ObjectsRedraw(); 
           return(0);
         }
     }
// check for long or short position possibility
   if((perceptron() > 0) && (TradeLong=True) && (AW > 0 && lime_AW != 0.0) && (up_signal_buffer_2 != EMPTY_VALUE));
     { //long
       ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Bid - sl * Point, 0, "AI", 
                          MagicNumber, 0, Blue); 
                          
       //----
       if(ticket < 0) 
         {
           Sleep(20000);
           prevtime = Time[1];
         }
     } 
   if((perceptron() < 0) && (TradeShort=True) &&(AW < 0 && red_AW != 0.0)  && ( down_signal_buffer_3 != EMPTY_VALUE ));
      
      
     { // short
       ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Ask + sl * Point, 0, "AI", 
                          MagicNumber, 0, Red); 
       if(ticket < 0) 
         {
           Sleep(20000);
           prevtime = Time[1];
         }
     }
//--- exit
   return(0);
  }
//+------------------------------------------------------------------+
//| The PERCEPTRON - Perception and recognizing function             |
//+------------------------------------------------------------------+
double perceptron() 
  {
  
  double AW = iCustom(NULL,0,"Awesome",short_mean,long_mean,meanAO,0,0);
   double w1 = x1 - ww1;
   double w2 = x2 - ww2;
   double w3 = x3 - ww3;
   double w4 = x4 - ww4;
   double a1 = iAC(Symbol(), aa1, aaa1);
   double a2 = iAC(Symbol(), aa2, aaa2);
   double a3 = iAC(Symbol(), aa3, aaa3);
   double a4 = iAC(Symbol(), aa4, aaa4);
   return(w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4);
 

  }
//+------------------------------------------------------------------+


